package com.example.kazuhirokondou.androidsextant;

import android.app.Activity;
import android.content.Context;
import android.hardware.Camera;
import android.hardware.Sensor;
import android.hardware.SensorEvent;
import android.hardware.SensorEventListener;
import android.hardware.SensorManager;
import android.os.Bundle;
import android.util.Log;
import android.view.Menu;
import android.view.MenuItem;
import android.view.SurfaceHolder;
import android.view.SurfaceView;
import android.widget.TextView;

import java.util.List;


public class SixtantActivity extends Activity implements SensorEventListener {

    /* 表示 */
//    TextView xViewA = null;
//    TextView yViewA = null;
//    TextView zViewA = null;
    TextView xViewO = null;
    TextView yViewO = null;
    TextView zViewO = null;

    /* 共通 */
    SensorManager sm = null;
    public boolean mIsMagSensor;
    public boolean mIsAccSensor;
    private static final int MATRIX_SIZE = 16;
    private Camera myCamera;
    private final Context context = this;

    /* 回転行列 */
    float[]  inR = new float[MATRIX_SIZE];
    float[] outR = new float[MATRIX_SIZE];
    float[]    I = new float[MATRIX_SIZE];

    /* センサーの値 */
    float[] orientationValues   = new float[3];
    float[] magneticValues      = new float[3];
    float[] accelerometerValues = new float[3];
    int cameraNum = Camera.getNumberOfCameras();

    final String CTAG = "SixtantActivity";
    @Override
    protected void onPause() {
        super.onPause();
        //センサーマネージャのリスナ登録破棄
        if (mIsMagSensor || mIsAccSensor) {
//        if (mIsMagSensor ) {
            sm.unregisterListener(this);
            mIsMagSensor = false;
            mIsAccSensor = false;
        }
    }

    @Override
    protected void onResume() {
        super.onResume();
        // センサの取得
        List<Sensor> sensors = sm.getSensorList(Sensor.TYPE_ALL);

        // センサマネージャへリスナーを登録(implements SensorEventListenerにより、thisで登録する)
        for (Sensor sensor : sensors) {

            if (sensor.getType() == Sensor.TYPE_MAGNETIC_FIELD) {
                sm.registerListener(this, sensor, SensorManager.SENSOR_DELAY_UI);
                mIsMagSensor = true;
            }

            if (sensor.getType() == Sensor.TYPE_ACCELEROMETER) {
                sm.registerListener(this, sensor, SensorManager.SENSOR_DELAY_UI);
                mIsAccSensor = true;
            }
        }
    }

    @Override
    protected void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        setContentView(R.layout.activity_camera_and_sixtant);


        SurfaceView mySurfaceView = (SurfaceView)findViewById(R.id.surface_View);
        SurfaceHolder holder = mySurfaceView.getHolder();
        holder.addCallback(mSurfaceListener);
        holder.setType(SurfaceHolder.SURFACE_TYPE_PUSH_BUFFERS);

        sm = (SensorManager) getSystemService(SENSOR_SERVICE);
//        xViewA = (TextView) findViewById(R.id.xbox);
//        yViewA = (TextView) findViewById(R.id.ybox);
//        zViewA = (TextView) findViewById(R.id.zbox);
        xViewO = (TextView) findViewById(R.id.xboxo);
        yViewO = (TextView) findViewById(R.id.yboxo);
        zViewO = (TextView) findViewById(R.id.zboxo);
    }


    @Override
    public boolean onCreateOptionsMenu(Menu menu) {
        // Inflate the menu; this adds items to the action bar if it is present.
        getMenuInflater().inflate(R.menu.menu_camera_and_sixtant, menu);
        return true;
    }

    @Override
    public boolean onOptionsItemSelected(MenuItem item) {
        // Handle action bar item clicks here. The action bar will
        // automatically handle clicks on the Home/Up button, so long
        // as you specify a parent activity in AndroidManifest.xml.
        int id = item.getItemId();

        //noinspection SimplifiableIfStatement
        if (id == R.id.action_settings) {
            return true;
        }

        return super.onOptionsItemSelected(item);
    }

    @Override
    public void onSensorChanged(SensorEvent event) {
        synchronized (this) {
            if (event.accuracy == SensorManager.SENSOR_STATUS_UNRELIABLE) return;

            switch (event.sensor.getType()) {
                case Sensor.TYPE_MAGNETIC_FIELD:
                    magneticValues = event.values.clone();
                    break;
                case Sensor.TYPE_ACCELEROMETER:
                    accelerometerValues = event.values.clone();
                    break;
            }

            if (magneticValues != null && accelerometerValues != null) {
//            if (magneticValues != null ) {

                SensorManager.getRotationMatrix(inR, I, accelerometerValues, magneticValues);

                //Activityの表示が縦固定の場合。横向きになる場合、修正が必要です
                SensorManager.remapCoordinateSystem(inR, SensorManager.AXIS_X, SensorManager.AXIS_Z, outR);
                SensorManager.getOrientation(outR, orientationValues);

//                Log.v("Orientation",
//                        String.valueOf(radianToDegree(orientationValues[0])) + ", " + //Z軸方向,azmuth
//                                String.valueOf(radianToDegree(orientationValues[1])) + ", " + //X軸方向,pitch
//                                String.valueOf(radianToDegree(orientationValues[2])));       //Y軸方向,roll
                xViewO.setText("Orientation X: " + orientationValues[0]);
                yViewO.setText("Orientation Y: " + orientationValues[1]);
                zViewO.setText("Orientation Z: " + orientationValues[2]);
//                xViewA.setText("Accel X: " + accelerometerValues[0]);
//                yViewA.setText("Accel Y: " + accelerometerValues[1]);
//                zViewA.setText("Accel Z: " + accelerometerValues[2]);

            }
        }
    }

    int radianToDegree(float rad){
        return (int) Math.floor( Math.toDegrees(rad) ) ;
    }

    @Override
    public void onAccuracyChanged(Sensor sensor, int accuracy) {
        // TODO 自動生成されたメソッド・スタブ
    }

   private SurfaceHolder.Callback mSurfaceListener = new SurfaceHolder.Callback(){
       @Override
       public void surfaceCreated(SurfaceHolder holder) {
           // TODO 自動生成されたメソッド・スタブ
           final String MTAG = " surfaceCreated";
           myCamera = Camera.open();
           //カメラの表示を縦に設定
           int result=0;
           android.hardware.Camera.CameraInfo info = new android.hardware.Camera.CameraInfo();
           result = (info.orientation + 270) % 360;
           result = (360 - result) % 360;
//           Log.d(CTAG + ":" + MTAG,"result :" + result);
           myCamera.setDisplayOrientation(result);
           try{
               myCamera.setPreviewDisplay(holder);
               Log.d(CTAG + MTAG,"setPreviewDisplay");
           }catch (Exception e){
               e.printStackTrace();
           }
       }

       @Override
       public void surfaceChanged(SurfaceHolder holder, int format, int width, int height) {
           // TODO 自動生成されたメソッド・スタブ
           final String MTAG = "surfaceChanged";
           Camera.Parameters parameters = myCamera.getParameters();
//           parameters.setPreviewSize(width, height);
           List<Camera.Size> previewSizes = myCamera.getParameters().getSupportedPreviewSizes();
           Camera.Size size = previewSizes.get(0);
           parameters.setPreviewSize(size.width, size.height);
//           Log.d(CTAG + ":" + MTAG,"CameraNum="+cameraNum);
//           Log.d(CTAG + ":" + MTAG, width + " : " + height);
//           Log.d(CTAG + ":" + MTAG, size.width + " : " + size.height);
           myCamera.setParameters(parameters);
           myCamera.startPreview();
       }

       @Override
       public void surfaceDestroyed(SurfaceHolder holder) {
           // TODO 自動生成されたメソッド・スタブ
           final String MTAG = "surfaceDestroyed";
           Log.d(CTAG + ":" + MTAG,"relese");
           myCamera.release();
           myCamera = null;
       }
   };
}
